{-  
 *  Programmer:	Piotr Borek
 *  E-mail:     piotrborek@op.pl
 *  Copyright 2014 Piotr Borek
 *
 *  Distributed under the terms of the GPL (GNU Public License)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-}

module Mp.UI.PlaylistState where

import Data.Binary

data NameList = NameList {
    nameListGet :: [String]
}

data SongList = SongList {
    songListGet :: [String]
}

instance Binary NameList where
    put (NameList d) = do
        put (011110 :: Word32)
        put (0 :: Int)
        put d

    get = do
        magic <- get :: Get Word32
        if magic /= 011110
            then return $ NameList []
            else do
                version <- get :: Get Int
                case version of
                    0 -> getVersion0
                    _ -> return $ NameList []
        where
            getVersion0 = do
                list <- get
                return $ NameList list

instance Binary SongList where
    put (SongList d) = do
        put (13131717 :: Word32)
        put (0 :: Int)
        put d

    get = do
        magic <- get :: Get Word32
        if magic /= 13131717
            then return $ SongList []
            else do
                version <- get :: Get Int
                case version of
                    0 -> getVersion0
                    _ -> return $ SongList []
        where
            getVersion0 = do
                list <- get
                return $ SongList list
